#include "GL/gl.h"
#include "GL/glx.h"
#include "forms.h"
#include <stdlib.h>
#include "first.h"
#include "cliser.h"
#include "stream.h"

FD_first *new_form() {
	FD_first *the;
   the =  create_form_first();
   fl_show_form(the->first,FL_PLACE_CENTER|FL_FREE_SIZE,FL_FULLBORDER,
               "My form");
	return the;

}

FL_IO_CALLBACK handle_socket(int ss,FD_first *ui) {
   struct sockaddr_in   cli;
   int                  lencli = sizeof(struct sockaddr_in);
   int                  cs; 

   FILE                *stream;
   XDR                  xdrs;
   CLISER_STREAM        the = {2.0,3.0,4.0}; 

   char                 buffer[1024];

   fprintf(stderr,"handle_socket: Data on socket %d\n",ss);
   cs = accept(ss,(struct sockaddr *) &cli, &lencli); 
   fprintf(stderr,"handle_socket: Connection on %d\n",cs);

   if( !(stream = fdopen(cs,"r")) ) {
      fprintf(stderr,"ser0_serve_block: fdopen(%d) failed\n",cs);
      close(cs);
      return NULL;
   }
   xdrstdio_create(&xdrs,stream,XDR_DECODE);
 
/* If no data on stream, clean-up and return ... */
 
   if( !xdr_CLISER_STREAM(&xdrs,&the) )  goto Cleanup;
 
   if( the.a < 0 ) {
      fprintf(stderr,"ser0_serve_block: Shutting down server\n");
      ser0_stop(ss);
      return NULL;
   }
 
   sprintf(buffer,"a: %g  b: %g  c: %g\n",the.a,the.b,the.c);
   fl_set_input(ui->result,buffer);
 
Cleanup:
   xdr_destroy(&xdrs);
   fclose(stream);
   close(cs);
   return NULL;   
}

int main(int argc, char *argv[])
{
   static int   ss;

   FD_first *the;
   fl_initialize(&argc, argv, "FormDemo", 0, 0);
   the = new_form();
   if( (ss = ser0_start(5002)) > 0 ) {
      fprintf(stderr,"%s: Starting service\n",argv[0]); 
      fl_add_io_callback(ss,FL_READ,handle_socket,the);
	}
   

   fl_do_forms();
   fl_finish();
   return 0;
}

void button1_callback(FL_OBJECT *the, long stuff) {
	fprintf(stderr,"button1_callback: In routine\n");
	new_form();
}

void button2_callback(FL_OBJECT *the, long stuff) {
	fprintf(stderr,"button2_callback: In routine ... closing form\n");
   fl_hide_form(the->form);
}

void button3_callback(FL_OBJECT *the, long stuff) {
	fprintf(stderr,"button2_callback: In routine ... Exiting\n");
   exit(1);
}

void big_button_callback(FL_OBJECT *the, long stuff) {
	fprintf(stderr,"big_button_callback: %ld\n",stuff);
}
